#!/usr/bin/env python
# -*- coding:utf-8 -*-
#
# PyXmahjongg Interface pour xmahjongg
# version 0.1 du  01/11/2006

# *  This program is free software; you can redistribute it and/or
# *  modify it under the terms of the GNU Library General Public License
# *  as published by the Free Software Foundation; either version 2 of
# *  the License, or (at your option) any later version.
# *
# *  This program is distributed in the hope that it will be useful,
# *  but WITHOUT ANY WARRANTY; without even the implied warranty of
# *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# *  GNU Library General Public License for more details.
# *
# *  You should have received a copy of the GNU Library General Public
# *  License along with this program; if not, write to the Free Software
# *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# *
# *  Copyright (C) 2006 mcclinews

try:
  import pygtk
  pygtk.require('2.0')
except ImportError:
  pass
  
import os, pickle, subprocess
from subprocess import PIPE
import datetime,time
import utils
import popen2

chemin=os.path.expanduser("~/.xmahjongg/")

class Commun:

    def ouvre(self):
        dbpath=os.path.expanduser("~/.xmahjongg/mahrc")
        return dbpath

    def litchemins(self):
        """ Récupère les chemlins du programme et des données """
        cheminmahrc = self.ouvre()
        defmah=open(cheminmahrc,'r')
        valdef = pickle.load(defmah)
        defmah.close()
        chemindata = valdef['chemindata']
        mycmd = valdef['cheminprog']
        return (mycmd, chemindata)

    def faitarg(self, chemindata):
        """ Préparation des arguments de ligne de commande """
        valdef = utils.Defauts().lit(chemindata)
        tuile=valdef['tuile']
        fond=valdef['fond']
        layout = valdef['layout']
        geometry = valdef['geometry']
        #
        options="-a "+ "--tiles " + tuile + " --bg " + fond + " --layout " + layout + " --geometry " + geometry #+ memoire
        return options
        
    def existe(self):
        """ Cherche le pid du programme Xmahjongg """
        comd = "/bin/kill"
        comarg = " -p xmahjongg"
        comtout = "/bin/kill -p xmahjongg"
        repin, repout , reperr = os.popen3(comtout)
        numpid = repout.read()
        erreur = reperr.read()
        if numpid :
            repin.close(), repout.close(), reperr.close()
            return numpid
        else:
            repin.close(), repout.close(), reperr.close()
            return False
       
        
    def tue(self):
        """ Tuer le Xmahjongg avant relance ou quitte """
        comd = "/bin/kill"
        comarg="xmahjongg"
        comtout = "/bin/kill xmahjongg"
        try:
            repin, repout = os.popen2(comtout)
            repin.close(), repout.close()
            for i in range(100):
                pass
            return
        except:
            print "erreur dans le kill"
        
class Lance:
    """ En réponse à choix Nouvelle """
    
    def ecritnum(self, boardnumber):
        # écrit numero partie en cours dans mahdef.txt
        utils.Oldjeu().ecritold(boardnumber)
        # 
        numgame = utils.Oldjeu().litold()
        # sauve date et numero de partie dans mahrc
        numdate = time.strftime("%Y-%m-%d/%Hh%M", time.localtime(None))
        jeudate = numdate+"/"+numgame
        utils.Defauts().ecrit(jeu=jeudate)

    def lance(self, mycmd, myarg):
        # tue le mahjongg precedent si existe
        numpid=Commun().existe()
        if numpid:
            Commun().tue()
        # lance un nouveau jeu
        comtout= mycmd + " " + myarg
        p= subprocess.Popen(mycmd + " " + myarg, shell=True, stderr=PIPE, close_fds=True)
        numpid = p.pid
        boardnumber = p.stderr.readline()
        return numpid, boardnumber

    def __init__(self) :

        chemins = Commun().litchemins()
        mycmd = chemins[0]
        chemindata = chemins[1]
            
        self.defauts=os.path.expanduser("~/.xmahjongg/mahdef.txt")
        myarg=Commun().faitarg(chemindata)
        numpid, boardnumber = self.lance(mycmd, myarg)
        # on va ecrire la sortie sdterr dans mahdef.txt
        # uniquement si elle comporte un numero de partie
        if boardnumber :
            self.ecritnum(boardnumber)
        return
        
class Relance:
    """ En réponse à choix Recommencer """

    def lance(self, mycmd, myarg):
        p= subprocess.Popen(mycmd + " " + myarg, shell=True, stderr=None, close_fds=True)
        numpid = p.pid
        return numpid

    def __init__(self) :

        chemins = Commun().litchemins()
        mycmd = chemins[0]
        chemindata = chemins[1]
        
        myarg=Commun().faitarg(chemindata)
        # lit dans mahdef le numero de partie en cours
        # c'est la derniere partie inscrite
        numgame = utils.Oldjeu().litold()
        # le rajoute aux arguments
        myarg=myarg + " -n " + numgame
        # cherche le pid du programme et le ferme
        numpid=Commun().existe()
        if numpid:
            Commun().tue()
        # relance la meme partie
        self.lance(mycmd, myarg)
        return
        
class Lancenew:
    """ En réponse à choix de partie dans liste ou par numero """
    
    def ecritnum(self, numgame):
        # on écrit la partie dans mahdef.txt ou elle peut 
        # être retrouvée par Relance()
        garde = "board number " + numgame
        utils.Oldjeu().ecritold(garde)
        
        # on ecrit la date et numero de partie dans mahrc
        # ou ils sont retrouvés par choix d'une partie (choixpartie)
        numdate = time.strftime("%Y-%m-%d/%Hh%M", time.localtime(None))
        jeudate = numdate+"/"+numgame
        utils.Defauts().ecrit(jeu=jeudate)

    def lance(self, mycmd, myarg, barrestatut):
        # tue le mahjongg precedent si existe
        numpid=Commun().existe()
        if numpid:
            Commun().tue()
        # lance un nouveau jeu
        utils.Defauts().ecritstatut(barrestatut)
        p= subprocess.Popen(mycmd + " " + myarg, shell=True, stderr=None, close_fds=True)
        return

    def __init__(self, numgame, barrestatut) :

        chemins = Commun().litchemins()
        mycmd = chemins[0]
        chemindata = chemins[1]
        
        myarg=Commun().faitarg(chemindata)
        # rajoute le numero de partie aux arguments
        myarg=myarg + " -n " + numgame
        # on écrit la partie dans mahdef.txt
        if numgame :
            self.ecritnum(numgame)
        self.lance(mycmd, myarg, barrestatut)
        return
        