#!/usr/bin/env python
# -*- coding:utf-8 -*-
#
# PyXmahjongg Interface pour xmahjongg
# version 0.1 du  01/11/2006

# *  This program is free software; you can redistribute it and/or
# *  modify it under the terms of the GNU Library General Public License
# *  as published by the Free Software Foundation; either version 2 of
# *  the License, or (at your option) any later version.
# *
# *  This program is distributed in the hope that it will be useful,
# *  but WITHOUT ANY WARRANTY; without even the implied warranty of
# *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# *  GNU Library General Public License for more details.
# *
# *  You should have received a copy of the GNU Library General Public
# *  License along with this program; if not, write to the Free Software
# *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# *
# *  Copyright (C) 2006 mcclinews

try:
  import pygtk
  pygtk.require('2.0')
except ImportError:
  pass
  
import os, sys
import gtk,gtk.glade
import string
import re
import utils

chemin=os.path.expanduser("~/.xmahjongg/")

def nettoie_chaine(chaine) :
    # vire les tab ou espace en début de ligne
    chaine = chaine.strip('"\t" ')
    # coupe la chaine quand 1 ou x espaces
    # ne garde que les données utiles
    p = re.compile('\s+')
    chaine = p.split(chaine)
    return chaine
    

def save_pixbuf(gdkwin, filename):
    # pour sauvegarder les dessins affichés dans un fichier png
    # pas utilisé car problème de taille de la copie à régler
    cmap = gtk.gdk.colormap_get_system()
    pixbuf = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, False, 8, 500, 400)
    pixbuf.get_from_drawable(gdkwin, cmap, 0, 0, 0, 0, 500, 400)
    filename = chemin + filename + ".png"
    pixbuf.save(filename, "png")
          
def gen_pixbuf(largeur, hauteur):
    '''Créer un pixbuf à partir d'un fichier représentant un domino neutre'''
    imagefile = chemin + "thintile2.gif"
    pixbuf = gtk.gdk.pixbuf_new_from_file(imagefile)
    scaled=pixbuf.scale_simple(largeur,hauteur,gtk.gdk.INTERP_BILINEAR)
    return scaled

    
def lit_layout_kyodai(laydata):
    ''' les fichiers de layout kyodai ont un format particulier'''
    element = []
    ligne = laydata.readline()
    i = 0
    for level in range(5) :
        for row in range(20) :
            for col in range(34) :
                if ligne[i] == "1" :
                    element.append([row,col,level])
                i = i + 1
    laydata.close()
    return element

def lit_layout(laydata):
    layencours = []
    for ligne in laydata.readlines():
        if len(ligne) == 1 or ligne[0] == "#" :
            pass
        else :
            # oter la fin de ligne
            ligne = ligne[:-1]
            element = nettoie_chaine(ligne)
            element.reverse()
            layencours.append(element)
    layencours.sort()
    lay2 = []
    for element in layencours :
        element.reverse()
        lay2.append(element)
    laydata.close()
    return lay2
        
def decode_layout(filename):
    ''' lecture du début du fichier pour reconnaitre un type Kyodai'''
    laydata = open(filename,'r')
    ligne1 = laydata.readline()
    if "Kyodai" in ligne1 :
        ligne2 = laydata.readline()
        layencours = lit_layout_kyodai(laydata)
        return layencours
    else : 
        layencours = lit_layout(laydata)
        return layencours

    

class GereLayout:

    def on_window1_destroy(obj):
        obj.destroy()

    def on_quitbutton_clicked(obj):
        obj.destroy()
        
    def suivant(self, hbox):
        # pour effacer le premier dessin affiché, 
        # sinon, le deuxième arrive en-dessous 
        if len(hbox.get_children()) > 1 :
            ancienform=hbox.get_children()[1]
            ancienform.destroy()
        return
        
    def fct_clic(objet, widget, hbox, area, nom, ecriture):
        if widget.get_active():
            if ecriture:
                utils.Defauts().ecrit(layout=nom)
                fichier = nom
            GereLayout().suivant(hbox)
            vbox12 = gtk.VBox(False,5)
            vbox12.set_border_width(4)
            vbox12.show()
            area = gtk.DrawingArea()
            area.show()
            vbox12.pack_start(area,True,True,5)
            hbox.pack_end(vbox12,True,True,10)
            fichier = chemin + "thintile2.gif"
            da = area
            da.connect("expose-event", on_expose, nom)
                        

             
class AfficheLayout:

    def list_fichiers(self,path):
        fichiers = []
        for root, dirs, files in os.walk(path):
            for file in files :
                fichiers.append(os.path.join(root,file))
        fichiers.sort()
        return fichiers 

    def creliste(self, xml, chemindata, layout):
    
        self.cherche = chemindata + "layouts"
        self.zonevisu=xml.get_widget("vbox11")
        # la fenetre horizontale où on mettra en fin la vue de l'image
        self.voitlayout=xml.get_widget("hbox1")
        self.da = xml.get_widget("drawarea")
        self.liste = self.list_fichiers(self.cherche)
        if len(self.liste)>1:
            bouton = gtk.RadioButton(None, None)
            for i in range(len(self.liste)):
                self.nomchoix = os.path.split(self.liste[i])[1]
                bouton = gtk.RadioButton(bouton, self.nomchoix)
                bouton.connect("toggled", GereLayout().fct_clic, self.voitlayout,  self.da, self.liste[i], True)
                if self.liste[i] == layout:
                    bouton.set_active(True)
                bouton.show()
                self.zonevisu.pack_start(bouton,False,False,3)
        
    def __init__(self):
        self.xmlout = gtk.glade.XML ('choixlayout.glade')
        self.xmlout.signal_autoconnect(GereLayout.__dict__)
        # on recupere les valeurs inscrites de layout
        valdef = {}
        valdef = utils.Defauts().lit(None)
        chemindata = valdef['chemindata']
        layout = valdef['layout']
        #
        self.creliste(self.xmlout, chemindata, layout)
        
    # Gives us the ability to do: widgets['widget_name'].action()
    def __getitem__(self, key):
        return self.xmlout.get_widget(key)



        
                
def on_expose(da, event, *args):
    # on recupere la fenetre drawable
    gdkwin = da.window
    # on cree un nouveau contexte graphique (plein d'options possibles)
    graphcont = gdkwin.new_gc()
    # taille en pixels - largeur et hauteur du domino modele
    # x et y marge cotés et haut/bas pour centrer un peu
    # rangdecal, le petit décalage entre dominos pour simuler le relief
    largeur = 30
    hauteur = 40
    xmarge = 20
    ymarge = 20
    rangdecal = 3
#     filename = "ram"
    filename = args[0]
    defaut= decode_layout(filename)
    for item in defaut :
        if item[2] == 0 :
            yplace = (int(item[0])*hauteur/2) + ymarge
            xplace = (int(item[1])*largeur/2) + xmarge
        if item[2] > 0 :
            yplace = (int(item[0])*hauteur/2) + ymarge - (rangdecal*int(item[2]))
            xplace = (int(item[1])*largeur/2) + xmarge + (rangdecal*int(item[2]))
        gdkwin.draw_pixbuf(graphcont, gen_pixbuf(largeur, hauteur), 0, 0, xplace, yplace, -1, -1)
    # pour sauver le dessin en png
    # pas encore au point
    # save_pixbuf(gdkwin,filename)
