#!/usr/bin/env python
# -*- coding:utf-8 -*-
#
## PyXmahjongg Interface pour xmahjongg
# version 0.1 du  01/11/2006

# *  This program is free software; you can redistribute it and/or
# *  modify it under the terms of the GNU Library General Public License
# *  as published by the Free Software Foundation; either version 2 of
# *  the License, or (at your option) any later version.
# *
# *  This program is distributed in the hope that it will be useful,
# *  but WITHOUT ANY WARRANTY; without even the implied warranty of
# *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# *  GNU Library General Public License for more details.
# *
# *  You should have received a copy of the GNU Library General Public
# *  License along with this program; if not, write to the Free Software
# *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# *
# *  Copyright (C) 2006 mcclinews

try:
  import pygtk
  pygtk.require('2.0')
except ImportError:
  pass
  
import subprocess, os, sys, pickle
import gtk,gtk.glade
import string
#
import utils
import lancejeu
#

class AfficheChoix:
    """ s'occupe du choix des parties deja jouees ou par numero"""
    def __init__(self, mainwindow) :
        self.mainwindow = mainwindow
        self.xml3 = gtk.glade.XML("choixpartie.glade")
        dic = {"on_choixpartie_close" : self.on_choixpartie_close, 
               "on_bvalider_clicked" : self.on_bvalider_clicked,
               "on_numpartie_changed" : self.on_numpartie_changed,
               "on_listeparties_changed" : self.on_listeparties_changed,
               "on_destroywidget" : self.on_destroywidget                
              }
        self.xml3.signal_autoconnect(dic)
        listepart=self.xml3.get_widget("listeparties")
        self.winpart = self.xml3.get_widget("choixpartie")
        self.winpart.show()
        self.remplir_liste(listepart)
#
    def __getitem__(self, key):
        global dictchoix
        self.dictchoix = self.xml3.get_widget(key)
        return self.xml3.get_widget(key)

    def remplir_liste(self, listepart):
        # Créer les instances du modele 
        Store = Modelchoix()
        # Attacher le modele au combo
        mdl = Store.get_model()
        listepart.set_model(mdl)
        listepart.set_text_column(0)
                
        
# class GereChoix:


    def on_choixpartie_close(self,fenetre):
        objet.destroy()
        return

    def on_bvalider_clicked(self,fenetre):
        partiechoisie = ""
        choixentry = ""
        # Le choix est dans la liste ?
        combo = self.__getitem__('listeparties')
        modele = combo.get_model()
        ligne = combo.get_active()
        if ligne >= 0:
            partiechoisie = modele[ligne][0]
        
        # Le choix est dans la zone de saisie ?
        entry = self.__getitem__('numpartie')
        choixentry = entry.get_text()
    
        # On vérifie
        if choixentry > "0":
        # le numero de partie a été tapé
            mempartie = choixentry
        else:
            if partiechoisie > "0":
            # la partie vient de la liste
                mempartie = string.split(partiechoisie, "/")[2]
        bar = self.mainwindow['statusbar']
        a = lancejeu.Lancenew(mempartie, bar)
        fen = self.__getitem__('choixpartie')
        fen.destroy()

    def on_numpartie_changed(self,entry):
        combo = self.__getitem__('listeparties')
        combo.set_active(-1)
        combo.child.set_text("")
        return

    def on_listeparties_changed(self,combo):
        entry = self.__getitem__('numpartie')
        entry.set_text("")
        return

    def on_destroywidget(self,fenetre):
        fenetre.destroy()
        return


class Modelchoix:
    def __init__(self):

        self.modele = gtk.ListStore(str,str,str)
        # Récupérer les donnees dans ~/.xmahjongg/mahrc
        defauts = {}
        defauts = utils.Defauts().lit(None)
        # Ne prendre que la liste de jeux
        jeux = defauts['jeux']
        
        for item in jeux :
            # Placement des données récupérées
            # un peu d'espaces pour la présentation
            presitem = string.join(string.split(item, "/")," /  ")
            iter0 = self.modele.append(None)
            # presitem = date / heure / numero_partie
            self.modele.set_value(iter0, 0, presitem)

    def get_model(self):
        """ Retourne le modele """
        if self.modele:
            return self.modele
        else:
            return None

    