#!/usr/bin/env python
# -*- coding:utf-8 -*-
#
# PyXmahjongg Interface pour xmahjongg
# version 0.1 du  01/11/2006

# *  This program is free software; you can redistribute it and/or
# *  modify it under the terms of the GNU Library General Public License
# *  as published by the Free Software Foundation; either version 2 of
# *  the License, or (at your option) any later version.
# *
# *  This program is distributed in the hope that it will be useful,
# *  but WITHOUT ANY WARRANTY; without even the implied warranty of
# *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# *  GNU Library General Public License for more details.
# *
# *  You should have received a copy of the GNU Library General Public
# *  License along with this program; if not, write to the Free Software
# *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# *
# *  Copyright (C) 2006 mcclinews

try:
  import pygtk
  pygtk.require('2.0')
except ImportError:
  pass
  
import subprocess, os, sys, pickle
import gtk,gtk.glade
import string
import lancejeu
import utils

def erreur(texte):
    if texte == 'noprog':
        print "Le programme Xmahjongg est absent !"
        exit

# chercher chemin du programme Xmahjongg
# pourrait être fait à l'installation du programme
programme = "xmahjongg"
if os.path.isfile('/usr/local/bin/'+programme):
    mycmd = "/usr/local/bin/"+programme
    chemindata = "/usr/local/share/xmahjongg/"
else:
    if os.path.isfile('/usr/bin/'+programme):
        mycmd = "/usr/bin/"+programme
        chemindata = "/usr/share/xmahjongg/"
    else:
        erreur('noprog')
        
# créer dossier et fichier nécessaires dans le home
# devrait être fait à l'installation du programme
chemin=os.path.expanduser("~/.xmahjongg/")
if not os.path.isdir(chemin):
    os.mkdir(chemin)
if not os.path.isfile(chemin+'mahrc'):
    newset = utils.Defauts().initialise(chemindata,mycmd) 


class ItemDisplay:
    """ Affichage des images après redimensionnement si nécessaire """

    def gen_pixbuf(self, imagefile):
        """ Créer un pixbuf à partir d'un fichier """
        pixbuf = gtk.gdk.pixbuf_new_from_file(imagefile)
        largeur=pixbuf.get_width()
        hauteur=pixbuf.get_height()
        largmax = 400
        hautmax = 150
        # ajuster la hauteur largeur à une taille raisonnable
        if largeur > largmax:
            limg = largmax
            ratio = int(largeur/limg)
            himg = int(hauteur/ratio)
            scaled = pixbuf.scale_simple(limg,himg,gtk.gdk.INTERP_BILINEAR)
        else:
            limg = largeur
            himg = hauteur
            scaled=pixbuf.scale_simple(100,100,gtk.gdk.INTERP_BILINEAR)
        if himg > hautmax:
            himg = hautmax
            ratio = int(hauteur/himg)
            limg = int(largeur/ratio)
            scaled = pixbuf.scale_simple(limg,himg,gtk.gdk.INTERP_BILINEAR)
        return scaled
		
    def __init__(self, chemin):
        self.vbox2 = gtk.VBox(False,5)
        self.vbox2.set_border_width(4)
        self.vbox2.show()
        self.image = gtk.Image()
        scaled=self.gen_pixbuf(chemin)
        self.image.set_from_pixbuf(scaled)
        self.image.show()
        self.vbox2.pack_start(self.image, False, True, 0)

        
class GerePref:

    def on_prefwin_destroy(obj):
        obj.destroy()
        return
    
    def on_quitbutton_clicked(obj):
        obj.destroy()
        return
        
    def suivant(self, hbox):
        """ pour effacer le premier dessin affiché, 
        sinon, le deuxième arrive en-dessous """
        if len(hbox.get_children()) > 1 :
            ancienform=hbox.get_children()[1]
            ancienform.destroy()
        return
        
    def fct_clic(objet, widget, hbox, item, nom, ecriture):
        global chemindata
        if widget.get_active():
            if ecriture:
                if item == "tuile":
                    utils.Defauts().ecrit(tuile=nom)
                    fichier=nom
                else :
                    utils.Defauts().ecrit(fond=nom)
                    fichier=nom
            GerePref().suivant(hbox)
            montre=ItemDisplay(fichier).vbox2
            montre.show()
            hbox.pack_end(montre,True,True,10)            
        
class AffichePref:
   
    def list_fichiers(self,path):
        fichiers = []
        for root, dirs, files in os.walk(path):
            for file in files :
                fichiers.append(os.path.join(root,file))
        fichiers.sort()
        return fichiers 

    def creliste1(self, xml, defaut,chemindata):
        """ la liste des tuiles """
        self.cherche = chemindata + "tiles/"
        self.zonetuiles=xml.get_widget("vbox11")
        # la fenetre horizontale ou on mettra en fin la vue de l'image
        self.voittuiles=xml.get_widget("hbox1")
        self.liste = self.list_fichiers(self.cherche)
        if len(self.liste)>1:
            bouton = gtk.RadioButton(None, None)
            for i in range(len(self.liste)):
                # ne pas afficher tout le chemin, juste le nom du fichier
                self.nomchoix = os.path.split(self.liste[i])[1]
                bouton = gtk.RadioButton(bouton, self.nomchoix)
                bouton.connect("toggled", GerePref().fct_clic, self.voittuiles, "tuile", self.liste[i], True)
                # activer le bouton radion du choix mémorisé dans mahrc
                if self.liste[i]==defaut:
                    bouton.set_active(True)
                bouton.show()
                self.zonetuiles.pack_start(bouton,False,False,3)
        
    def creliste2(self, xml, defaut,chemindata):
        """ la liste des fonds de jeu """
        self.cherche = chemindata + "backgrounds/"
        self.zonefond=xml.get_widget("vbox21")
        # la fenetre horizontale ou on mettra en fin la vue de l'image
        self.voitfond=xml.get_widget("hbox2")
        self.liste = self.list_fichiers(self.cherche)
        if len(self.liste)>1:
            bouton = gtk.RadioButton(None, None)
            for i in range(len(self.liste)):
                self.nomchoix = os.path.split(self.liste[i])[1]
                bouton = gtk.RadioButton(bouton, self.nomchoix)
                bouton.connect("toggled", GerePref().fct_clic, self.voitfond, "fond", self.liste[i], True)
                # afficher image du choix par defaut
                if self.liste[i]==defaut:
                    bouton.set_active(True)
                bouton.show()
                self.zonefond.pack_start(bouton,False,False,3)
                
    def __init__(self, chemindata):
        self.xmlpref = gtk.glade.XML("choixpref.glade")
        self.xmlpref.signal_autoconnect(GerePref.__dict__)
        # on récupère les valeurs inscrites de tuile et fond
        valdef = {}
        valdef = utils.Defauts().lit(chemindata)
        defaut1 = valdef['tuile']
        defaut2 = valdef['fond']
        # 
        self.creliste1(self.xmlpref, defaut1,chemindata)
        self.creliste2(self.xmlpref, defaut2,chemindata)

    def __getitem__(self, key):
        return self.xmlpref.get_widget(key)


class GereMain:

    def on_mainwindow_destroy(self):
        numpid=lancejeu.Commun().existe()
        if numpid:
            lancejeu.Commun().tue()
        gtk.main_quit()
        
    def on_quittermenu_activate(self):
        numpid=lancejeu.Commun().existe()
        if numpid:
            lancejeu.Commun().tue()
        gtk.main_quit()
    
    def destroyFunction(self, obj):
        numpid=lancejeu.Commun().existe()
        if numpid:
            lancejeu.Commun().tue()
        gtk.main_quit()

    def on_nouvelle_activate(self, *args):
        bar = widgets['statusbar']
        a=lancejeu.Lance()
        utils.Defauts().ecritstatut(bar)

    def on_refaire_activate(self, *args):
        bar = widgets['statusbar']
        a=lancejeu.Relance()
        utils.Defauts().ecritstatut(bar)

    def on_choisir_activate(self, *args):
        import partie
        dictchoix= partie.AfficheChoix(widgets)
        bar = widgets['statusbar']

    def on_a_propos_activate(obj):
        import aide
        affiche = aide.Apropos()

    def on_aidejeu_activate(obj):
        import aide
        affiche = aide.Aide()

    def on_initialiser_activate(self):
        newset = utils.Defauts().initialise(chemindata,mycmd)
    
    def on_tuiles_activate(self, *args):
        widgetpref = AffichePref(chemindata)

    def on_modeles_activate(self, *args):
        import layout
        widgetmod = layout.AfficheLayout()
    
class AfficheMain:
    def __init__(self):
        self.widgets = gtk.glade.XML ('pymahjongg.glade', "mainwindow")
        self.widgets.signal_autoconnect(GereMain.__dict__)
        toolbar=self.widgets.get_widget("toolbar1")
        self.remplir_toolbar(toolbar)
        
    # Gives us the ability to do: widgets['widget_name'].action()
    def __getitem__(self, key):
        return self.widgets.get_widget(key)

    def remplir_toolbar(self, toolbar):
        # rajouter les boutons dans la toolbar
        # ça marchait pas comme je voulais dans glade
        nouveau=gtk.ToolButton(gtk.STOCK_NEW)
        nouveau.set_label("Nouvelle")
        nouveau.connect("clicked", GereMain().on_nouvelle_activate)
        nouveau.show()
        refaire=gtk.ToolButton(gtk.STOCK_REFRESH)
        refaire.set_label("Recommencer")
        refaire.connect("clicked", GereMain().on_refaire_activate)
        refaire.show()
        choisir=gtk.ToolButton(gtk.STOCK_INDEX)
        choisir.set_label("Choisir")
        choisir.connect("clicked", GereMain().on_choisir_activate)
        choisir.show()
        pref=gtk.ToolButton(gtk.STOCK_PREFERENCES)
        pref.show()
        pref.connect("clicked", GereMain().on_tuiles_activate)
        separ=gtk.SeparatorToolItem()
        separ.set_draw(False)
        separ.set_expand(True)
        separ.show()
        quitter=gtk.ToolButton(gtk.STOCK_QUIT)
        quitter.connect("clicked", GereMain().destroyFunction)
        quitter.show()
        toolbar.insert(nouveau, 0)
        toolbar.insert(refaire, 1)
        toolbar.insert(choisir, 2)
        toolbar.insert(pref, 3)
        toolbar.insert(separ,4)
        toolbar.insert(quitter, -1)


def main():
    gtk.main()
    return 0


if __name__ == "__main__":
    widgets = AfficheMain()
    main()    
