#!/usr/bin/env python
# -*- coding:utf-8 -*-
#
# PyXmahjongg Interface pour xmahjongg
# version 0.1 du  01/11/2006

# *  This program is free software; you can redistribute it and/or
# *  modify it under the terms of the GNU Library General Public License
# *  as published by the Free Software Foundation; either version 2 of
# *  the License, or (at your option) any later version.
# *
# *  This program is distributed in the hope that it will be useful,
# *  but WITHOUT ANY WARRANTY; without even the implied warranty of
# *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# *  GNU Library General Public License for more details.
# *
# *  You should have received a copy of the GNU Library General Public
# *  License along with this program; if not, write to the Free Software
# *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# *
# *  Copyright (C) 2006 mcclinews

try:
  import pygtk
  pygtk.require('2.0')
except ImportError:
  pass
  
import os, pickle
import string
import datetime,time



class Defauts:

    def ecritstatut(self, barstatut):
        """ écrit le numero de la partie dans la barre d'état"""
        idinfo = barstatut.get_context_id("numeropartie")
        numgame = "Partie numéro : " + Oldjeu().litold()
        barstatut.push(idinfo, numgame)
        return
           
    def ouvre(self):
        """ ouverture du fichier de paramètres """
        dbpath=os.path.expanduser("~/.xmahjongg/mahrc")
        return dbpath
        
    def initialise(self,chemindata,mycmd):
        """ crée le fichier de paramètres avec des valeurs par défaut """
        self.chemin=chemindata
        dbpath=self.ouvre()
        defmah=open(dbpath,'w')
        defauts = {}
        
        # première écriture dans fichier
        defauts['tuile'] = self.chemin+'tiles/'+'thick.gif'
        defauts['fond'] = self.chemin+'backgrounds/'+'green.gif'
        defauts['geometry'] = "1020x760"
        dateinit = time.strftime("%Y-%m-%d/%Hh%M", time.localtime(None))
        listjeux = [dateinit+'/1', dateinit+'/2', dateinit+'/3', dateinit+'/4', dateinit+'/5']
        defauts['jeux'] = listjeux
        defauts['layout'] = self.chemin+'layouts/'+'default'
        defauts['chemindata'] = chemindata
        defauts['cheminprog'] = mycmd
        pickle.dump(defauts, defmah)
        defmah.close()
        return
        
    def ecrit(self, tuile=None, fond=None, jeu=None, layout=None):
        # on récupère les valeurs inscrites dans .xmahjongg/mahrc
        cheminmahrc = self.ouvre()
        valdef=self.lit(cheminmahrc)
        defauts = {}
        defauts = valdef
        # on prépare les nouvelles valeurs dans defauts
        # ou on remet les anciennes pour pas les perdre
        if tuile :
            defauts['tuile'] = tuile
        else:
            defauts['tuile'] = valdef['tuile']
            
        if fond :
            defauts['fond'] = fond
        else:
            defauts['fond'] = valdef['fond']
        if layout :
            defauts['layout'] = layout
        else : 
            defauts['layout'] = valdef['layout']
            
        if jeu :
            valjeux = valdef['jeux']
            # tri sur le premier element (date)
            valjeux.sort()
            numgames = set()
            for i in range(len(valjeux)) :
                element = string.split(valjeux[i], "/")
                # cree liste avec seulement les numeros de parties
                numgames.add(element[2])
            if jeu not in numgames:
                # si le jeu pas encore inscrit, il remplace le plus ancien
                valjeux[0] = jeu
                defauts['jeux'] = valjeux
        # on écrit les nouvelles valeurs
        dbpath = self.ouvre()
        defmah = open(dbpath,'w')
        pickle.dump(defauts, defmah)
        defmah.close()
        return
           
        
    def lit(self,chemindata):
        # Récupération des valeurs par defaut pour les arguments
        valdef={}
        valjeux=[]
        
        dbpath=self.ouvre()
        defmah=open(dbpath,'r')
        valdef = pickle.load(defmah)
        defmah.close()
        
        self.chemin = valdef['chemindata']
        
        if valdef['tuile'] == "":
            valdef['tuile'] = self.chemin+'tiles/'+"thick.gif"
    
        if valdef['fond'] == "":
            valdef['fond'] = self.chemin+'backgrounds/'+"green.gif"
            
        if valdef['layout'] == "":
            valdef['layout'] = self.chemin+'layouts/'+"default"
            
        if valdef['geometry'] == "":
            valdef['geometry'] ="1020x760"
        # obligation de trier les dates de sauvegarde des jeux
        # pour pouvoir repérer ensuite la plus ancienne
        valjeux = valdef['jeux']
        valjeux.sort()
        valdef['jeux'] = valjeux
        return valdef
 
class Oldjeu:

    def litold(self):
        # lit le numero de la dernière partie jouée
        encours=os.path.expanduser("~/.xmahjongg/mahdef.txt")
        garde = open(encours,'r')
        board=garde.readline()
        garde.close()
        numgame=string.split(board)[2]
        return numgame
    
    def ecritold(self, partie):
        # écrit le numéro de la partie en cours
        encours=os.path.expanduser("~/.xmahjongg/mahdef.txt")
        garde = open(encours,'w')
        garde.write(partie)
        garde.close()
        return partie
 